#!/bin/bash

openssl genrsa -des3 -out privkey.pem 2048
openssl req -new -key privkey.pem -out cert.csr -days 365
openssl x509 -days 365 -req -in cert.csr -extfile /usr/share/ssl/openssl.cnf -extensions v3_ca -signkey privkey.pem -out cacert.pem -trustout


cp cacert.pem /etc/httpd/conf/ssl.crt/server.crt
cp privkey.pem /etc/httpd/conf/ssl.key/server.key