<?php
/*
Copyright (C) 2003 Arnim Wiezer <awiezer@g2l.bio.uni-goettingen.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/



include "functions.php";

session_start();
if (!session_is_registered('authdata') || $authdata['login'] != $sadmin)
{ 
   loginform(); 
} 
else
{
  $allusers = array();
  $sconfig  = get_super_config();
  
  /* form sent ! */
  if ($newuser != "") 
    {
      add_http_user($newuser, $newpw);
      exit;
    }
  
  if (count($todelete) > 0)
    del_http_users($todelete);
  
  // User has changed the secureBLAST database and user configuration
  if ($sblastchange == 1)
    {
      if (empty($dbtodelete))
	$dbtodelete = array();
      small_head();
      echo "<b>Your new secureBLAST config (<i>$cfile</i>) looks like this:</b><br>";
      write_sblast_config($sconfig, $desc, $rw_users_selected, $ro_users_selected, $new_db, $new_desc, $dbtodelete);
      exit;
    }
  
  small_head();
  echo "<h3>User configuration from <i>$htpasswd</i></h3>\n";
  echo "<h4>These are your available users:</h4>\n";
  
  
  echo "<FORM ACTION=\"$blasturl/admin.php?PHPSESSID=".session_id();
  echo "\" METHOD=POST ENCTYPE= \"multipart/form-data\">";
  
  echo "<table width=30% border=1>";	  
  echo "<tr><th bgcolor=cornflowerblue>Username</th><th bgcolor=cornflowerblue>delete ?</th></tr>\n";
  
  $lines = get_htpasswd();
  array_pop($lines);
  asort($lines);
  
  foreach ($lines as $line) 
    { 
      list( $username, $password ) = explode( ':', $line ); 
      echo "<tr><td>$username</td>";
      echo "<td align=center><input type=\"checkbox\" name=\"todelete[]\" value=\"$username\">";
      echo "</td></tr>\n";
    }
  echo "<tr><th bgcolor=lightgrey>new User</th><th bgcolor=lightgrey>password</th>\n";
  echo "<tr><td bgcolor=lightgrey><input type=\"text\" name=\"newuser\" size=12 maxlen=12></td>";
  echo "<td bgcolor=lightgrey><input type=\"password\" name=\"newpw\" size=12 maxlen=12></td></tr>\n";
  echo "</table><br>";
  echo "<INPUT TYPE=\"submit\" VALUE=\"UPDATE\"><hr>\n";
  echo "</form>\n";
  
  
  // **************************************************************
  echo "<h3>secureBLAST configuration from <i>$cfile</i></h3>\n";
  echo "hint: You can select multiple users by pressing the \"CTRL\" key while you click at the usernames.\n";
  
  echo "<FORM ACTION=\"$blasturl/admin.php?PHPSESSID=".session_id();
  echo "\"METHOD=POST ENCTYPE= \"multipart/form-data\">\n";
  echo "<table width=70% border=1>";  
  echo "<tr><th bgcolor=cornflowerblue>delete ?</th><th bgcolor=cornflowerblue>database</th><th bgcolor=cornflowerblue>description</th><th bgcolor=lightgreen>users (ro)</th><th bgcolor=crimson>users (rw)</th></tr>";
  

  foreach ($lines as $line) // all users from htpasswd
    { 
      list( $username, $password ) = explode( ':', $line ); 
      array_push($allusers, $username); 
    }
  asort($allusers);
  asort($sconfig["dbs"]);
  
  foreach ($sconfig["dbs"] as $db)
    {
      
      echo "<tr><td align=center><input type=\"checkbox\" name=\"dbtodelete[]\" value=\"$db\"></td>";
      
      echo "<td>$db</td>";
      echo "<td><input type=\"text\" name=\"desc[$db]\" value=\"".$sconfig[$db][desc];
      echo "\" size=40 maxlen=40></td>";
      echo "<td fgcolor=\"red\"><select name=\"ro_users_selected[$db][]\" multiple size=5>\n";
      foreach ($allusers as $user)
	{
	  if (in_array($user, $sconfig[$db]["ro_users"]))
	    echo "<option selected value=\"$user\">$user\n";
	  else
	    echo "<option value=\"$user\">$user\n";
	}
      echo "</select></td>";
      
      echo "<td><select name=\"rw_users_selected[$db][]\" multiple size=5>\n";
      foreach ($allusers as $user)
	{
	  if (in_array($user, $sconfig[$db]["rw_users"]))
	    echo "<option selected value=\"$user\">$user\n";
	  else
	    echo "<option value=\"$user\">$user\n";
	}
      echo "</select></td>";
    }
  
  echo "<tr><th bgcolor=lightgrey colspan=5>New BLAST database configuration</th></tr>\n";
  echo "<tr><th bgcolor=lightgrey>database</th><th bgcolor=lightgrey>database-file</th><th bgcolor=lightgrey>description</th>";
  echo "<th bgcolor=lightgrey>users (ro)</th><th bgcolor=lightgrey>users (rw)</th></tr>\n";
  
  echo "<tr><td>name: <input type\"text\" name=\"new_db\" size=12 maxlen=12></td>\n";
  echo "<td>filename: <input type=\"file\" name=\"userfile\"  accept=\"text/*\"></td>\n";
  
  echo "<td><input type=\"text\" name=\"new_desc\" value =\"default description\"size=40 maxlen=40></td>\n";
  
  echo "<td><select name=\"ro_users_selected[new_db_sel][]\" multiple size=5>\n";
  foreach ($allusers as $user)
    echo "<option value=\"$user\">$user\n";
  echo "</select></td>";
  
  echo "<td><select name=\"rw_users_selected[new_db_sel][]\" multiple size=5>\n";
  foreach ($allusers as $user)
    echo "<option value=\"$user\">$user\n";
  echo "</select></td>";
  
  
  echo "</tr>";

  echo "</table><br>";
  echo "<input type=\"hidden\" name=\"sblastchange\" value=\"1\">\n";
  echo "<INPUT TYPE=\"submit\" VALUE=\"UPDATE\"><hr>\n";
  echo "</form>\n";
  echo "</body></html>\n";
}

php?>