<?php

/* NOTICE: register_globals in your php.ini file has to be "on" */
/* Please configure these variables: */

$cfile   = "/etc/sblast.conf";
$blasturl = "http://192.168.4.43/sblast";
$blastdir = "/var/www/html/sblast/";
$dbdir    = "/opt/blast/db";
$htpasswd = "/etc/httpd/.htpasswd";
$formatdb = "/var/www/html/sblast/formatdb"; 
$admin    = "wwwadmin@192.168.4.43";
// user that is allowed to access the admin module
$sadmin   = "wwwadmin";

/*
Copyright (C) 2003 Arnim Wiezer <awiezer@g2l.bio.uni-goettingen.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/* --------------------------------- */

$tmpdir = ini_get("upload_tmp_dir");
if (empty($tmpdir))
     $tmpdir = "$blastdir";

function loginform() 
{ 
  global $blasturl, $admin, $pwtries;

  echo "<HTML><HEAD><TITLE>secureBLAST login page</TITLE></HEAD><BODY bgcolor=white> ";
  echo "Access to this site is restricted please <h2>login ...</h2><hr>";
  echo "<FORM ACTION=\"$blasturl/index.php?".session_id()."\" METHOD=POST>";
  echo "<table border=0 bgcolor=lightgrey><tr><td>";
  echo "Username:</td><td><INPUT TYPE=\"text\" NAME=\"username\"></td></tr>";
  echo "<td>Password:</td><td><INPUT TYPE=\"password\" NAME=\"password\"></td></tr>";
  //  echo "<INPUT TYPE=\"image\" VALUE=\"Login\" src=\"login.gif\" border=0></FORM>";
  echo "<tr><td><INPUT TYPE=\"submit\" VALUE=\"Login\"></td></tr></table></FORM>";
  echo "<hr>If you have trouble with the login precedure or forgotten your password, please contact ";
  echo "<a href=\"mailto:$admin\">$admin</a>";
  echo "</BODY></HTML>";
}

function small_head()
{
  global $blasturl;
  echo "<html><head><title>secureBLAST - admin</title></head>\n";
  echo "<body bgcolor=white>\n";
  echo "
       <table width=35%>
       <tr><td><img src=\"$blasturl/images/g2l.gif\"></td>
       <td><a href=\"$blasturl\"><img src=\"$blasturl/images/sblast.png\" border=0></a></td>
       <td>
       <form action=\"$blasturl/logout.php?PHPSESSID=".session_id()."\" METHOD=POST>
       <font color=red><input type=\"submit\" name=logout value=\"logout\"></font>
       </td>
       <td><a href=\"$blasturl\">HOME</a></td></tr>
       </form>
       </table><hr>";
}

function auth($login = '', $passwd = '') 
{ 
  mt_srand(make_seed());
  session_start(md5(uniqid(mt_rand() / 50000 * (50000 - 1000) + 10000))); 

  global $PHP_SELF, $authdata, $htpasswd, $cfile, $pwtries; 
  $check = ! empty( $login ); // $check is true if $login is empty
    
  if ( is_array($authdata) ) 
      return true; 
  elseif ( $check ) 
    { 
      if (userislocked($login))
	{
	  echo "<html><head><title>An error occured.</title></head><body>";
	  errormsg("Sorry, your account is locked. Did you enter a wrong password more than 3 times ?");
	  echo "</body></html>";
	}
      if (session_is_registered('pwtries'))
	  $pwtries++;
      else
	{
	  $pwtries = 0;
	  session_register('pwtries');
	}
      if ($pwtries >= 2)
	{
	  lockuser($login);
	  session_unregister('authdata');
	  session_unregister('barray');
	  session_unregister('pwtries');
	  session_destroy();
	  setcookie(session_name(),"",time()+7200,"/");
	  errormsg("Sorry. You entered a wrong password 3 times. Come back in three hours !");
	  
	  exit;
	}
      
      // read userconfig
      $fp = fopen( $htpasswd, 'r' ); 
      if ($fp == FALSE)
	errormsg("Configfile $htpasswd could not be opened !");
      $file_contents = fread( $fp, filesize( $htpasswd ) ); 
      fclose( $fp ); 

      // read secureBLAST config
      $fp = fopen( $cfile, 'r' ); 
      if ($fp == FALSE)
	errormsg("Configfile $cfile could not be opened !");
      $sconfig = fread( $fp, filesize( $cfile ) ); 
      fclose( $fp ); 

      $lines = explode ( "\n", $file_contents ); 
      $lines_sconfig = explode ( "\n", $sconfig ); 

      foreach ( $lines as $line ) 
	{ 
	  list( $username, $password ) = explode( ':', $line ); 
	  if ( $username == $login )
	    { 
	      
	      $salt = substr( $password , 0 , 2 ); 
	      $enc_pw = crypt( $passwd, $salt ); 
	  
	      if ( $password == "$enc_pw" )
		{ 
		  $authdata = array("login"=>$login); 
		  
		  // $_SESSION['authdata'] = $authdata;
		  
		  
		  // *********************************************************
		  $dbentry = array(); // contains "name" and "desc"ription
		  $dbread = array();  // contains n dbentries of readeable dbs
		  $dbwrite = array(); // contains n dbentries of writeable dbs

		  
		  foreach ( $lines_sconfig as $line )
		    {
		      if (substr($line, 0, 1) != "#") // this line is not a comment
			{
			  $arr  = explode(":", rtrim($line));
			  $dbentry["name"] = $arr[0]; // db name
			  $dbentry["desc"] = $arr[1]; // db description
			  $userlist = explode(",", $arr[2]); // list of users
			  			  
			  if (in_array($login, $userlist) or in_array("guest", $userlist))
			    {
			      array_push($dbread, $dbentry);
			      $authdata["dbread"] = $dbread;
			    }
			  
			  if (in_array("@".$login, $userlist))
			    {
			      array_push($dbread, $dbentry);
			      $authdata["dbread"] = $dbread;

			      array_push($dbwrite, $dbentry);
			      $authdata["dbwrite"] = $dbwrite;
			      // example for accessing...    echo "<h1>@W:", $authdata['dbwrite'][0]['name'],"@</h1>";
			    }
			}
		    }
		  
		  session_register('authdata'); 
		  session_unregister('pwtries');
		  return true; 
		  break; 
		} 
	    }
	}
    }
}


function make_seed() 
{
  list($usec, $sec) = explode(' ', microtime());
  return (float) $sec + ((float) $usec * 100000);
}


function authorized($haystack, $needle)
{
  $authorized = false;
  foreach ($haystack as $db)
    {
      if ($db['name'] ==  $needle)
	{
	  $authorized = true;
	  return  $authorized;
	}
    }
  return $authorized;
}


function noupdate($filename)
{
  echo "<font size=+2 color=red>Your database file >$filename< doesn't exist or ";
  echo "you are not allowed to update ";
  echo "this database ! Your request does not look like an UPDATE.<br>";
  echo "Please contact your BLAST administrator: $admin.</font><p>\n";
  exit;
}

function errormsg($msg)
{
  global $admin;
  echo "<font size=+2 color=red>Arrrrgghhh... something went wrong. ";
  echo "$msg. Please contact your BLAST administrator ($admin).</font></body></html>\n";
  exit;
}

function fileobsolete($username) // unlock user if the lockfile is older than 3 hours
{
  global $tmpdir;
  $lockname = "$tmpdir/".$username.".user.lock";

  $filemod = filemtime($lockname); // unix timestamp for the lockfile
  $current = time();               // unix timestamp for current time
  
  $fyear  = date("Y", $filemod);
  $fday   = date("d", $filemod);
  $fmonth = date("m", $filemod);
  $fhour  = date("G", $filemod);

  $cyear  = date("Y", $current);
  $cday   = date("d", $current);
  $cmonth = date("m", $current);
  $chour  = date("G", $currend);

  if ($fyear == $cyear && $fmonth == $cmonth && $fday == $cday)
    {
      if ($fhour+3 >= $chour)
	return false;
    }
  else 
    {
      unlockuser($lockname);
      return true;
    }
}

function lockuser($username) // lock user after 3 failed login tries
{
  global $tmpdir;
  $lockname = "$tmpdir/$username.user.lock";
  
  if (!file_exists($lockname)) 
    { 
      $result = touch($lockname); // Create blank file 
      chmod($lockname,0666); 
      return $result; 
    } 
  else
    return false;
}

function unlockuser($username) // delete user-lockfile
{
  global $tmpdir;
  $lockname = "$tmpdir/$username.user.lock";

  if (file_exists($lockname)) 
    { 
      $result = unlink($lockname);
      return $result;
    } 
}

function userislocked($username) // check wether a user is locked 
{
  global $tmpdir;
  $lockname = "$tmpdir/".$username.".user.lock";
  
  if (!file_exists($lockname) || fileobsolete($username))
    return false;
  else 
    return true;
}


function lockdb($filename) // lock databases to be read-only 
{
  global $tmpdir;
  $lockname = "$tmpdir/$filename.lock";
  
  if (!file_exists($lockname)) 
    { 
      $result = touch($lockname); // Create blank file 
      chmod($lockname,0666); 
      return $result; 
    } 
  else
    return false;
}

function unlockdb($filename) // unlock databases
{
  global $tmpdir;
  $lockname = "$tmpdir/$filename.lock";

  if (file_exists($lockname)) 
    { 
      $result = unlink($lockname); // Create blank file 
      return $result;
    } 
}


function islocked($filename) // is the database locked ?
{
  global $tmpdir;
  $lockname = "$tmpdir/$filename.lock";
  
  if (file_exists($lockname))
    return true;
  else 
    return false;
}

function get_htpasswd()
{
  global $htpasswd;
  // read userconfig
  $fp = fopen( $htpasswd, 'r' ); 
  if ($fp == FALSE)
      errormsg("Configfile $cfile could not be opened !");
  $file_contents = fread( $fp, filesize( $htpasswd ) ); 
  fclose( $fp ); 
  
  $lines = explode ( "\n", $file_contents ); 
  //  array_pop($lines); // last element is an empty line
  
  return $lines;
}

function write_htpasswd($lines)
{
  global $htpasswd;
  $filecontent = implode("\n", $lines); 
  $fp = fopen( $htpasswd, 'w');
  if ($fp == FALSE)
    {
      echo "Configfile $htpasswd could not be opened for writing !";
      exit;
    }
  
  if (!fwrite($fp, $filecontent))
    {
      echo "Could not write to $htpasswd !";
      exit;
    }
  fclose($fp);
}

function add_http_user($newuser, $newpw)
{
  global $blasturl;
  $lines = get_htpasswd();

  if (empty($newpw) || empty($newuser))
    {
      echo "Sorry, empty usernames or empty passwords are not allowed !<br>";
      echo "Click <a href=\"$blasturl/admin.php\">HERE</a> to go back !\n";
      exit;

    }
  foreach ($lines as $line)
    {
      list( $username, $password ) = explode( ':', $line ); 
      if ($username == $newuser)
	{
	  echo "$username already exists. Please choose another name !\n";
	  echo "Click <a href=\"$blasturl/admin.php\">HERE</a> to go back !\n";
	  exit;
	}
    }
  array_pop($lines);
  $enc_pw = crypt($newpw,substr($newpw,0,2));
  small_head();
  echo "Created new user: <b>$newuser</b><br>\n";
  echo "Click <a href=\"$blasturl/admin.php\">HERE</a> to go back !\n";
  array_push($lines, "$newuser:$enc_pw\n");
  write_htpasswd($lines);
}

function del_http_users($todelete)
{
  global $sadmin;
  $lines_new = array();
  $lines = get_htpasswd();

  foreach ($lines as $line)
    {
      list( $username, $password ) = explode( ':', $line ); 
      if (!in_array($username, $todelete) || $username == $sadmin)
	  array_push($lines_new, $line);
    }
  if (!empty($lines_new))
      write_htpasswd($lines_new);
}

function get_super_config()
{
  global $cfile;
  $all_dbs = array();

  // read secureBLAST config
  $fp = fopen( $cfile, 'r' ); 
  $sconfig = fread( $fp, filesize( $cfile ) ); 
  fclose( $fp ); 
  
  $lines = explode ( "\n", $sconfig ); 
  array_pop($lines);

  foreach ($lines as $line)
    {
      if (substr($line, 0, 1) != "#") // this line is not a comment
	{
	  $ro_users = array();
	  $rw_users = array();
	  $arr  = explode(":", rtrim($line));
	  $userlist = explode(",", $arr[2]); // list of users

	  array_push($all_dbs, $arr[0]);
	  foreach ($userlist as $user)
	    {
	      if (substr($user, 0, 1) == "@")
		{
		  $user = str_replace("@", "", $user);
		  array_push($rw_users, $user);
		}
	      else
		  array_push($ro_users, $user);
	    }
	}
      /*
              return array with databases, descriptions, ro_users and rw_users
      */
      $superconfig["dbs"] = $all_dbs; // array of database names
      $superconfig[$arr[0]]["desc"] = $arr[1]; 
      $superconfig[$arr[0]]["ro_users"] = $ro_users;
      $superconfig[$arr[0]]["rw_users"] = $rw_users;
    }
  return $superconfig;
}

function write_blastrc($rclines)
{
  global $blastdir;
  $rclines_new = implode("\n", $rclines);

  /* write new blast.rc ------------------------------------------------- */
  
  $fp = fopen( "$blastdir/blast.rc", 'w');
  if ($fp == FALSE)
    {
      echo "Configfile $blastdir/blast.rc could not be opened for writing !";
      exit;
    }
  
  if (!fwrite($fp, $rclines_new))
    {
      echo "Could not write to $blastdir/blast.rc !";
      echo "Please make sure, that $blastdir/blast.rc is owned by your apache user and user-writeable";
      exit;
    }
  fclose($fp); 
}

function blastrc($db_new, $result, $dbtodelete)
{
  global $blastdir;
  $new_lines = array();

  $fp = fopen( $blastdir."/blast.rc", 'r' ); 
  if ($fp == FALSE)
    errormsg("$blastdir/blast.rc could not be opened !");
  $file_contents = fread( $fp, filesize( $blastdir."/blast.rc" ) ); 
  fclose($fp);
  
  
  $lines = explode("\n", $file_contents);

  // process each line of blast.rc
  foreach ($lines as $line) 
    {
      $tmp_entry = array();
      $entry = explode(" ", $line);
      // $entry is an array containing all parts of the important line

      if ($entry[0] == "blastn" || $entry[0] == "blastp" || 
	  $entry[0] == "blastx" || $entry[0] == "tblastn" || $entry[0] == "tblastx")

	// these are the lines containing the information about the databases
	{
	  if ($result == "DNA")
	    {
	      // only use these programs for DNA sequences
	      if ($entry[0] == "blastn" || $entry[0] =="tblastn" || $entry[0] =="tblastx")
		array_push($entry, $db_new);
	    }
	  elseif ($result == "protein") // protein sequence programs
	    {
	      // these programs for protein sequences
	      if ($entry[0] == "blastx" || $entry[0] == "blastp")
		array_push($entry, $db_new);
	    }
	  
	  // check for dbs to delete
	  foreach ($entry as $db)
	    {
	      if (!in_array($db, $dbtodelete))
		array_push($tmp_entry, $db);
	    }
	  $line = implode(" ", $tmp_entry);
	}
      array_push($new_lines, $line);
    }
  write_blastrc($new_lines);
}


function del_db_file($dbtodelete)
{
  global $dbdir;
  
  foreach ($dbtodelete as $db)
    {
      system ("rm -rf $dbdir/$db $dbdir/$db.*");
    }
}

function write_sblast_config($sconfig, $desc, $rw_users_selected, $ro_users_selected, $new_db, $new_desc, $dbtodelete)
{
  global $cfile, $dbdir, $formatdb;
  $lines = array();
  $aa    = array ("D",",E","F","L","S","Y","W","L","P","H","Q","R","I","M","N","K","S","R","V");

  /* ------------------------------- new database ?! */

  if (!empty($new_db) and is_uploaded_file($_FILES['userfile']['tmp_name']))
  {
    $new_db = str_replace(" ", "_", $new_db); // spaces in database filenames will produce errors
    if (file_exists($dbdir."/".$new_db))
      errormsg("The file $new_db already exists. Please choose another name");


    $userfile = $_FILES['userfile']['tmp_name'];
    if (!rename($userfile, "$dbdir/".$new_db))
	errormsg("Your file $userfile ($oriname) could not be moved!");

    /* ---- read file, choose between dna and protein, formatdb, blast.rc */

    echo "<h3>Checking for DNA/protein sequences...</h3>\n";
    $fp = fopen( $dbdir."/".$new_db, 'r' ); 
    if ($fp == FALSE)
      errormsg("$dbdir/$new_db could not be opened !");
    $file_contents = fread( $fp, filesize( $dbdir."/".$new_db ) ); 
    fclose($fp);

    $seqlines = explode("\n", $file_contents);
    for ($i = 0; $i <= 10; $i++) // check 10 lines for DNA sequences
      {
	if ($seqlines[$i][0] != ">")
	  if (in_array($seqlines[$i][0], $aa))
	    {
	      $result       = "protein";
	      $result_short = "T";
	    }
	  else
	    {
	      $result       = "DNA";
	      $result_short = "F";
	    }
      }

    echo "<h3>Found: $result - sequence. Done !</h3>";

    echo "<h3>Running formatdb...</h3>\n";
    if (!file_exists($formatdb))
      {
	errormsg("$formatdb was not found !\n");
      }
    system ("cd $dbdir ; $formatdb -i $dbdir/$new_db -p $result_short");
    echo "<h3>Done !</h3>";
  }

    /* -------------- new BLAST.RC -------------------------------------- */

    blastrc($new_db, $result, $dbtodelete);
    
    /* ------------- delete DBS ---------------------------------------- */
    if (!empty($dbtodelete))
	del_db_file($dbtodelete);
        
    /* ---------- build new sblast config ------------------------------------ */
    
    if (!empty($new_db))
      {
	array_push($sconfig["dbs"], $new_db);
	$sconfig[$new_db]["desc"]   = $new_desc;
	$desc[$new_db] = $new_desc;
	$ro_users_selected[$new_db] = $ro_users_selected["new_db_sel"];
	$rw_users_selected[$new_db] = $rw_users_selected["new_db_sel"];
      }



  $head = "# sblast config file.
# format: database.fas:description:user1,user2,@user3
# in this case the database file is called database.fas (this has to be
# exacly the filename !) and the users \"user1\", \"user2\" and \"user3\" have
# read access to this database. \"user3\" additionally has update-access.
# \"guest\" means that all users can access this database AND the user \"guest\"
# can only see this databases.";

    array_push($lines, $head);

  foreach ($sconfig["dbs"] as $db)
    {
      if (!in_array($db, $dbtodelete))
	{
	  $tmp_rw_arr   = array();
	  $tmp_ro_arr   = array();
	  $tmp_rw_users = "";
	  $tmp_ro_users = "";
	  
	  if (!empty($rw_users_selected[$db]))
	    {
	      foreach ($rw_users_selected[$db] as $user)
		{
		  $user = "@".$user;
		  array_push($tmp_rw_arr, $user);
		}
	      $tmp_rw_users = join(",", $tmp_rw_arr);
	    }
	  
	  if (!empty($ro_users_selected[$db]))
	    {
	      foreach ($ro_users_selected[$db] as $user)
		{
		  if (!empty($rw_users_selected[$db]))
		    {
		      if (!in_array($user, $rw_users_selected[$db]))
			array_push($tmp_ro_arr, $user);
		    }
		  else
		    array_push($tmp_ro_arr, $user);
		}
	      $tmp_ro_users = join(",", $tmp_ro_arr);
	    }
	  
	  
	  $line = $db.":".$desc[$db].":";
	  if (!empty($tmp_rw_users))
	    {
	      $line = $line.$tmp_rw_users;
	      if (!empty($tmp_ro_users))
		$line = $line.",".$tmp_ro_users;
	    }
	  else
	    {
	      if (!empty($tmp_ro_users))
		$line = $line.$tmp_ro_users;	      
	    }
	  $line = $line;
	  array_push($lines, $line);
	}
    }
  array_push($lines, "");

  /* ----------- write new sblast.conf -------------  */

  $filecontent = implode("\n", $lines); 
  echo "<pre>$filecontent</pre>";
  echo "<h3>This new configuration is valid after the next login !</h3>\n";
  $fp = fopen( $cfile, 'w');
  if ($fp == FALSE)
    {
      echo "Configfile $cfile could not be opened for writing !";
      exit;
    }
  
  if (!fwrite($fp, $filecontent))
    {
      echo "Could not write to $cfile !";
      echo "Please make sure, that $cfile is owned by your apache user and user-writeable";
      exit;
    }
  fclose($fp); 

}

function filehead($length, $file)
{
  $fp = fopen( $file, 'r' ); 
  $fcontent = fread( $fp, filesize( $file ) ); 
  fclose( $fp ); 
  
  $content = explode ( "\n", $fcontent ); 
  
  for ($i = 0; $i <= $length; $i++)
    {
      echo $content[$i]."\n";
    }
}

function get_contig_names($db)
{
  global $dbdir;
  $cnames = array();
  $fp = fopen( $dbdir."/".$db, 'r' ); 
  if ($fp == FALSE)
      errormsg("$dbdir/$db could not be opened !");

  while ($line = fgets($fp, 1000))
    {
      if (eregi("^>[a-z0-9]+[:space:]*", $line, $regs))
        {
          $name = str_replace(">", "", $regs[0]);
          array_push($cnames, $name);
        }
    }
  fclose($fp);
  return $cnames;
}

function get_seq_from_db($db, $contig, $start, $stop)
{
  global $dbdir;
  $seq = "";
  $tmpseq = "";
  $found = 0;
  $break = 0;
  $fp = fopen( $dbdir."/".$db, 'r' );
  if ($fp == FALSE)
      errormsg("$dbdir/$db could not be opened !");

  while ($line = fgets($fp, 1000))
    {
      if (eregi("^>[a-z0-9]+[:space:]*", $line, $regs) && $regs[0] == ">$contig")
	$found = 1;
      elseif ($found)
	{
	  $tmpseq = $tmpseq.$line;
	  if ($found && eregi("^>[a-z0-9]+[:space:]*", $line, $regs))
	    {
	      $seq = substr($tmpseq, $start-1, $stop-$start+1);
	      break;
	    }
	}
    }
  fclose($fp);
  return $seq;
}

php?>