<?php
/*
Copyright (C) 2003 Arnim Wiezer <awiezer@g2l.bio.uni-goettingen.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

---------------------------------------------------------------------------

The template of the HTML form was taken from NCBIs wwwblast package:

* Author:  Sergei Shavirin
*
* Initial Version Creation Date: 03/14/2000
*
* File Description:
*         Template for standalone BLAST Web page
*/

include "functions.php";

session_start();

if ( !auth($username, $password) ) 
{ 
   loginform(); 
} 
else
{

  // main -----------------------------
  // "Here comes the form..." (please sing to "Here comes the sun" from Zz Top) :-)
  echo "
  <HTML>
  <head>
   <TITLE>secureBLAST Search</TITLE>
   <meta http-EQUIV=\"content-type\" content=\"multipart/form-data\">
  </head>
  <BODY BGCOLOR=\"#FFFFFF\" LINK=\"#0000FF\" VLINK=\"#660099\" ALINK=\"#660099\">\n
  <table width=50%>
  <tr><td><img src=\"$blasturl/images/g2l.gif\"></td><td><img src=\"$blasturl/images/sblast.png\"></td>
  <td>
   <form action=\"$blasturl/logout.php?PHPSESSID=".session_id()."\" METHOD=POST>
   <font color=red><input type=\"submit\" name=logout value=\"logout\"></font>
  </td>
  </tr>
  <tr>
   <td>Database <a href=\"$blasturl/versions.php?PHPSESSID=".session_id()."\">version</a> information</td>
   <td>Direct <a href=\"$blasturl/seq.php?PHPSESSID=".session_id()."\">sequence</a> access</td>
  </tr>
  </form>
  </table>

  <hr>
  <h3>Welcome <i>$authdata[login]</i> ! Happy BLAST-ing... </h3>";

  /* display link, if the user is the admin */
  if ($authdata['login'] == $sadmin)
    {
      echo "<font color=red>\n";
      echo "<h4>You have administrative privileges. Click <a href=\"$blasturl/admin.php?PHPSESSID=".session_id()."\">here</a> ";
      echo "for the admin section.</h4></font><br>\n";
    }

  echo "<FORM ACTION=\"$blasturl/blast.php?PHPSESSID=".session_id()."\" METHOD=POST NAME=\"MainBlastForm\" ENCTYPE= \"multipart/form-data\">
  Choose program to use and database to search:</B><p>
  <a href=\"docs/blast_program.html\">Program </a>
  <select name = \"PROGRAM\">
      <option> blastn 
      <option> blastp 
      <option> blastx 
      <option> tblastn 
      <option> tblastx 
  </select>
  Database
  <select name = \"DATALIB\">\n";
  sort($authdata['dbread']);
  foreach ($authdata['dbread'] as $db )
    echo "<option VALUE =\"$db[name]\">$db[desc]\n";
  
  echo "</select>\n";
  echo "<a href=\"$blasturl/update.php?PHPSESSID=".session_id()."\">update</a><p>";
  echo "Enter sequence below in <a href=\"docs/fasta.html\">FASTA</a> format <br>\n";
  echo "<textarea name=\"SEQUENCE\" rows=6 cols=60></textarea><br>\n";
  echo "Or load it from disk \n";
  echo "<INPUT TYPE=\"file\" NAME=\"SEQFILE\"><p>\n";
  echo "<INPUT TYPE=\"button\" VALUE=\"Clear sequence\" onClick=\"MainBlastForm.SEQUENCE.value='';MainBlastForm.SEQUENCE.focus();\">\n";
  echo "<INPUT TYPE=\"submit\" VALUE=\"Search\"><hr>\n";
 
  echo "The query sequence is \n";
  echo "<a href=\"docs/filtered.html\">filtered</a> for low complexity regions by default.<BR>\n";
  echo "<a href=\"docs/newoptions.html#filter\">Filter</a>\n";
  echo " <INPUT TYPE=\"checkbox\" VALUE=\"L\" NAME=\"FILTER\" CHECKED> Low complexity\n";
  echo " <INPUT TYPE=\"checkbox\" VALUE=\"m\" NAME=\"FILTER\"> Mask for lookup table only<p>\n";
  echo "<a href=\"docs/newoptions.html#expect\">Expect</a>\n";
  echo "<select name = \"EXPECT\">\n";
  echo "    <option> 0.0001 \n";
  echo "    <option> 0.01 \n";
  echo "    <option> 1 \n";
  echo "    <option selected> 10 \n";
  echo "    <option> 100 \n";
  echo "    <option> 1000 \n";
  echo "</select>\n";
  echo "&nbsp;&nbsp;\n";
 
  echo "<a href=\"docs/matrix_info.html\">Matrix</a>\n";
  echo "<select name = \"MAT_PARAM\">\n";
  echo "    <option value = \"PAM30	 9	 1\"> PAM30 </option>\n";
  echo "    <option value = \"PAM70	 10	 1\"> PAM70 </option> \n";
  echo "    <option value = \"BLOSUM80	 10	 1\"> BLOSUM80 </option>\n";
  echo "    <option selected value = \"BLOSUM62	 11	 1\"> BLOSUM62 </option>\n";
  echo "    <option value = \"BLOSUM45	 14	 2\"> BLOSUM45 </option>\n";
  echo "</select>\n";
  echo "<INPUT TYPE=\"checkbox\" NAME=\"UNGAPPED_ALIGNMENT\" VALUE=\"is_set\"> Perform ungapped alignment<p> \n";
  echo "<a href=\"docs/newoptions.html#gencodes\">Query Genetic Codes (blastx only) </a>\n";
  echo "<select name = \"GENETIC_CODE\">\n";
  echo " <option value = \"1\" > Standard (1) \n";
  echo " <option value = \"2\" > Vertebrate Mitochondrial (2) \n";
  echo " <option value = \"3\" > Yeast Mitochondrial (3) \n";
  echo " <option value = \"4\" > Mold Mitochondrial; ... (4) \n";
  echo " <option value = \"5\" > Invertebrate Mitochondrial (5) \n";
  echo " <option value = \"6\" > Ciliate Nuclear; ... (6) \n";
  echo " <option value = \"19\" > Echinoderm Mitochondrial (9) \n";
  echo " <option value = \"10\" > Euplotid Nuclear (10) \n";
  echo " <option value = \"11\" > Bacterial (11) \n";
  echo " <option value = \"12\" > Alternative Yeast Nuclear (12) \n";
  echo " <option value = \"13\" > Ascidian Mitochondrial (13) \n";
  echo " <option value = \"14\" > Flatworm Mitochondrial (14) \n";
  echo " <option value = \"15\" > Blepharisma Macronuclear (15) \n";
  echo "</select>\n";
  echo "<BR>\n";
  echo "<a href=\"docs/oof_notation.html\">Frame shift penalty</a> for blastx \n";
  echo "<select NAME = \"OOF_ALIGN\"> \n";
  echo " <option value = \"6\" > 6\n";
  echo " <option value = \"7\" > 7\n";
  echo " <option value = \"8\" > 8\n";
  echo " <option value = \"9\" > 9\n";
  echo " <option value = \"10\"> 10\n";
  echo " <option value = \"11\"> 11\n";
  echo " <option value = \"12\"> 12\n";
  echo " <option value = \"13\"> 13\n";
  echo " <option value = \"14\"> 14\n";
  echo " <option value = \"15\"> 15\n";
  echo " <option value = \"16\"> 16\n";
  echo " <option value = \"17\"> 17\n";
  echo " <option value = \"18\"> 18\n";
  echo " <option value = \"19\"> 19\n";
  echo " <option value = \"20\"> 20\n";
  echo " <option value = \"25\"> 25\n";
  echo " <option value = \"30\"> 30\n";
  echo " <option value = \"50\"> 50\n";
  echo " <option value = \"1000\"> 1000\n";
  echo " <option selected VALUE = \"0\"> No OOF\n";
  echo "</select><p>\n";
  echo "<a href=\"docs/full_options.html\">Other advanced options:</a> \n";
  echo "&nbsp;&nbsp;&nbsp;&nbsp; \n";
  echo "<INPUT TYPE=\"text\" NAME=\"OTHER_ADVANCED\" VALUE=\"\" MAXLENGTH=\"80\"><hr>\n";
  echo "<INPUT TYPE=\"checkbox\" NAME=\"NCBI_GI\" >&nbsp;&nbsp;\n";
  echo "<a href=\"docs/newoptions.html#ncbi-gi\"> NCBI-gi</a>\n";
  echo "&nbsp;&nbsp;&nbsp;&nbsp;\n";
  echo "<INPUT TYPE=\"checkbox\" NAME=\"OVERVIEW\"  CHECKED> \n";
  echo "<a href=\"docs/newoptions.html#graphical-overview\">Graphical Overview</a>\n";
  echo "&nbsp;&nbsp;\n";
  echo "<a href=\"docs/options.html#alignmentviews\">Alignment view</a>\n";
  echo "<select name = \"ALIGNMENT_VIEW\">\n";
  echo "    <option value=0> Pairwise\n";
  echo "    <option value=1> master-slave with identities\n";
  echo "    <option value=2> master-slave without identities\n";
  echo "    <option value=3> flat master-slave with identities\n";
  echo "    <option value=4> flat master-slave without identities\n";
  echo "    <option value=7> BLAST XML\n";
  echo "    <option value=9> Hit Table\n";
  echo "</select>\n";
  echo "<BR>\n";
  echo "<a href=\"docs/newoptions.html#descriptions\">Descriptions</a>\n";
  echo "<select name = \"DESCRIPTIONS\">\n";
  echo "    <option> 0 \n";
  echo "    <option> 10 \n";
  echo "    <option> 50 \n";
  echo "    <option selected> 100 \n";
  echo "    <option> 250 \n";
  echo "    <option> 500 \n";
  echo "</select>\n";
  echo "&nbsp;&nbsp;\n";
  echo "<a href=\"docs/newoptions.html#alignments\">Alignments</a>\n";
  echo "<select name = \"ALIGNMENTS\">\n";
  echo "    <option> 0 \n";
  echo "    <option> 10 \n";
  echo "    <option selected> 50 \n";
  echo "    <option> 100 \n";
  echo "    <option> 250 \n";
  echo "    <option> 500 \n";
  echo "</select>\n";
  echo "<a href=\"docs/color_schema.html\">Color schema</a>\n";
  echo "<select name = \"COLOR_SCHEMA\">\n";
  echo "    <option selected value = 0> No color schema \n";
  echo "    <option value = 1> Color schema 1 \n";
  echo "    <option value = 2> Color schema 2  \n";
  echo "    <option value = 3> Color schema 3 \n";
  echo "    <option value = 4> Color schema 4 \n";
  echo "    <option value = 5> Color schema 5 \n";
  echo "    <option value = 6> Color schema 6 \n";
  echo "</select><p>\n";
  echo "<INPUT TYPE=\"button\" VALUE=\"Clear sequence\" onClick=\"MainBlastForm.SEQUENCE.value='';";
  echo "MainBlastForm.SEQFILE.value='';MainBlastForm.SEQUENCE.focus();\">\n";
  echo "<INPUT TYPE=\"submit\" VALUE=\"Search\">\n";   
  echo "</FORM><HR>\n";
  echo "<small>Comments and suggestions to: <address><a href=\"mailto:$admin\">$admin</a>\n";
  echo "</ADDRESS></small><br></body></html>\n";
}
php?>